--[[
Copyright 2008, 2009, 2010, 2011 João Cardoso
Sushi is distributed under the terms of the GNU General Public License (or the Lesser GPL).
This file is part of Sushi.

Sushi is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Sushi is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushi. If not, see <http://www.gnu.org/licenses/>.
--]]

local Sushi = LibStub('Sushi-2.0')
local Button = Sushi:GetClass('Button')
local Gray, old = Sushi:NewWidgetClass('GrayButton', {version = 1})
if not Gray then
	return
end


--[[ Events ]]--

function Gray:OnCreate()
	Button.OnCreate(self)
	
	local name = self:GetName()
	self.Left = _G[name..'Left']
	self.Middle = _G[name..'Middle']
	self.Right = _G[name..'Right']
	
	self:SetScript('OnMouseDown', self.OnMouseDown)
	self:SetScript('OnMouseUp', self.OnMouseUp)
	self:SetScript('OnShow', self.OnMouseUp)
	self:SetScript('OnDisable', nil)
	self:SetScript('OnEnable', nil)
	self:SetSmall(nil)
end

function Gray:OnMouseUp()
	self.Left:SetTexture('Interface/Buttons/UI-Panel-Button-Disabled')
	self.Middle:SetTexture('Interface/Buttons/UI-Panel-Button-Disabled')
	self.Right:SetTexture('Interface/Buttons/UI-Panel-Button-Disabled')
end

function Gray:OnMouseDown()
	self.Left:SetTexture('Interface/Buttons/UI-Panel-Button-Disabled-Down')
	self.Middle:SetTexture('Interface/Buttons/UI-Panel-Button-Disabled-Down')
	self.Right:SetTexture('Interface/Buttons/UI-Panel-Button-Disabled-Down')
end


--[[ API ]]--

function Gray:SetSmall(small)
	if small then
		self:SetHighlightFontObject('GameFontHighlightSmall')
		self:SetDisabledFontObject('GameFontDisableSmall')
		self:SetNormalFontObject('GameFontHighlightSmall')
	else
		self:SetHighlightFontObject('GameFontHighlight')
		self:SetDisabledFontObject('GameFontDisable')
		self:SetNormalFontObject('GameFontHighlight')
	end
end


--[[ Embedding ]]--

if not old then
	Button:Embed(Gray, 'OnCreate', 'SetSmall', 'frameType', 'template', 'insets', 'width')
else
	Gray:UpdateEmbeds()
end