--[[
Copyright 2008, 2009, 2010, 2011 João Cardoso
Sushi is distributed under the terms of the GNU General Public License (or the Lesser GPL).
This file is part of Sushi.

Sushi is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Sushi is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Sushi. If not, see <http://www.gnu.org/licenses/>.
--]]

local Sushi = LibStub('Sushi-2.0')
local Icon = Sushi:NewWidgetClass('IconCheck', {
	frameType = 'Button',
	insets = {left = 10, right = 150, top = 2, bottom = 18},
	version = 1,
})

if not Icon then
	return
end


--[[ Events ]]--

function Icon:OnCreate()
	self.SetIcon = self.SetNormalTexture
	self.SetChecked = self.SetValue
	self.GetChecked = self.GetValue
	self:SetSize(30, 30)
end

function Icon:OnAcquire()
	self.check = Sushi:CreateWidget('CheckButton', self)
	self.check:RegisterCallback('OnValueChanged', function(...) self:FireCallback('OnValueChanged', ...) end)
	self.check:RegisterCallback('OnUpdate', function(...) self:FireCallback('OnUpdate', ...) end)
	self.check:SetPoint('BOTTOMRIGHT', 15, -15)
end

function Icon:OnRelease()
	self.check:Release()
	self:SetIcon(nil)
end


--[[ Hacky API ]]--

function Icon:GetIcon()
	return self:GetNormalTexture():GetTexture()
end

function Icon:SetValue(...)
	self.check:SetValue(...)
end

function Icon:GetValue()
	return self.check:GetValue()
end

function Icon:SetText(...)
	self.check:SetText(...)
end

function Icon:GetText()
	return self.check:GetText()
end

function Icon:SetDescription(...)
	self.check:SetDescription(...)
end

function Icon:GetDescription()
	return self.check:GetDescription()
end

function Icon:SetDisabled(...)
	self.check:SetDisabled(...)
end

function Icon:IsDisabled()
	return self.check:IsDisabled()
end

Icon:UpdateEmbeds()