--[[
Copyright 2010, 2011 João Cardoso
Cornucopia is distributed under the terms of the GNU General Public License (or the Lesser GPL).
This file is part of Cornucopia.

Cornucopia is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Cornucopia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Cornucopia. If not, see <http://www.gnu.org/licenses/>.
--]]

local Menu = Cornucopia:CreateBar('Menu', {
	name = 'Menu',
	sets = 'Cornucopia_Menu_Sets',
	defaults = {
		point = 'BOTTOMLEFT',
		relPoint = 'BOTTOM',
		x = 39, y = 2
	}
})

function Menu:OnInitialize()
	local self = self.frame
	UpdateMicroButtonsParent(self)
	
	local numChildren = self:GetNumChildren()
	for i = 1, numChildren do
		local button = select(i, self:GetChildren())
		button:SetPoint('BOTTOMLEFT', (i - 1) * 26, 0)
	end
	
	self:SetSize(numChildren * 26, 36)
	self:SetFrameStrata('HIGH')
end